using System.Collections.Generic;
using System.Linq;
using skydiveLogs_api.Domain;
using skydiveLogs_api.DomainBusiness.Interfaces;
using skydiveLogs_api.DomainService.Repositories;

namespace skydiveLogs_api.DomainBusiness
{
    public class StatsByAircraftService : IStatsByAircraftService
    {
        #region Public Constructors

        public StatsByAircraftService(IJumpService jumpService,
                                      IIdentityService identityService,
                                      IStatsByAircraftRepository statsByAircraftRepository)
        {
            _jumpService = jumpService;
            _identityService = identityService;
            _statsByAircraftRepository = statsByAircraftRepository;
        }

        #endregion Public Constructors

        #region Public Methods

        /// <summary>
        /// Retrieves statistics grouped by aircraft.
        /// </summary>
        /// <returns>A collection of StatsByAircraft entities containing the statistics.</returns>
        public IEnumerable<StatsByAircraft> GetStats()
        {
            var allStats = _statsByAircraftRepository.GetAll(_identityService.ConnectedUser);
            if (!allStats.Any())
            {
                var allJumps = _jumpService.GetAllJumps();
                var results = new List<StatsByAircraft>();

                if (allJumps.Any())
                {
                    results = [.. allJumps.GroupBy(j => j.Aircraft.Name,
                                                   j => j,
                                                   (groupby, jumps) => new StatsByAircraft
                                                   {
                                                       Aircraft = groupby.ToString(),
                                                       Nb = jumps.Count(),
                                                       User = _identityService.ConnectedUser
                                                   })];
                }

                _statsByAircraftRepository.Add(results);
                return results;
            }

            return allStats;
        }

        /// <summary>
        /// Resets the aircraft statistics.
        /// </summary>
        public void Reset()
        {
            _statsByAircraftRepository.Delete(_identityService.ConnectedUser);
        }

        #endregion Public Methods

        #region Private Fields

        private readonly IIdentityService _identityService;
        private readonly IJumpService _jumpService;
        private readonly IStatsByAircraftRepository _statsByAircraftRepository;

        #endregion Private Fields
    }
}
